/* ISC (c) 2018+ Jackens * https://github.com/jackens/nanolight */

if (typeof window !== 'undefined') {
  window['module.exports'] = window['module.exports'] || {}
  window.require = window.require || function (id) { return window['module.exports'][id] }
}

(function () {
  var A = '<span class="'
  var B = '">'
  var Z = '</span>'
  var M = '-'
  var E = ' '
  var P = 'nanolight'
  var Q = 'quote'
  var G = 'single-'
  var L = 'block'
  var S = P + '-string'
  var C = P + '-comment'
  var N = P + '-number'
  var H = P + '-char'
  var K = P + '-keyword'

  C += E + C + M
  K += E + K + M
  S += E + S + M
  H += E + H + M

  var I = {
    '"': S + 'double-' + Q,
    "'": S + G + Q,
    '`': S + 'template'
  }

  var R = /(\d+(?:\.\d+)?)|(!|\$|%|&|\(|\)|\*|\+|,|-|\.|\/|:|;|<|=|>|\?|@|\[|\\|\]|\^|_|\{|\||\}|~)|(\W)(abstract|arguments|await|boolean|break|byte|case|catch|char|class|const|continue|debugger|default|delete|do|double|else|enum|eval|export|extends|false|final|finally|float|for|function|goto|if|implements|import|in|instanceof|int|interface|let|long|native|new|null|package|private|protected|public|return|short|static|super|switch|synchronized|this|throw|throws|transient|true|try|typeof|undefined|var|void|volatile|while|with|yield)(\W)/g

  var O = function (c) {
    return c.charCodeAt(0).toString(16)
  }

  var F = function (a, n, x, p, k, s) {
    return (n ? [A, N, B, n, Z] : x ? [A, H, O(x), B, x, Z] : k ? [p, A, K, k, B, k, Z, s] : []).join('')
  }

  var nanolight = function (code) {
    return code
      .split(/("(?:.|\n)*?"|'(?:.|\n)*?'|`(?:.|\n)*?`|\/\*(?:.|\n)*?\*\/|<!--(?:.|\n)*?-->|\/\/.*?\n)/g)
      .map(function (t) {
        var l = t.length
        var a = t[0]
        var z = t[l - 1]
        if (l > 1 && a === z && I[a]) {
          var h = O(a)
          return [A, H, h, B, a, Z, A, I[a], B, t.substr(1, l - 2), Z, A, H, h, B, a, Z].join('')
        }
        var b = a + t[1]
        var y = t[l - 2] + z
        var c = (l > 6 && a === '<' && z === '>' && C + L) ||
          (l > 3 && b === '/*' && y === '*/' && C + L) ||
          (l > 2 && b === '//' && z === '\n' && C + G + 'line')
        return c ? [A, c, B, t, Z].join('') : t.replace(R, F)
      })
      .join('')
  }

  if (typeof module !== 'undefined') {
    module.exports = nanolight
  } else if (typeof window !== 'undefined') {
    window['module.exports']['nanolight'] = nanolight
  }
})()
